/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Description: Define types in rtftools
 * Create: 2020-10-24
 */

#ifndef RTFTOOLS_RTFTOOLSRETURNCODE_H
#define RTFTOOLS_RTFTOOLSRETURNCODE_H
#include <cstdint>
namespace rtf{
namespace rtftools{
enum class RETURN_CODE : std::uint32_t {
    SUCCESS = 0,
    INIT_FAILED,            // initialize failed
    INIT_REPEATED,          // initialize repeated
    INVALID_PARAM,          // invalid param input
    QUERY_FAILED,           // query failed because of query process error
    QUERY_INVALID,          // query success but maintaind don't have target value
    EMPTY_DATATYPE_JSON,    // miss dataType msg file
    CREATE_FAILED,          // register&create sub, methodClient or fieldClient failed
    ERR_COMMUNICATION,      // cm communication failed
    ERR_DESERIALIZE,        // deserialize failed
    ERR_REQUEST,            // input params failed or serialize failed
};
}
}
#endif //RTFTOOLS_RTFTOOLSRETURNCODE_H
