/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 * Description: the implementation of RawBufferForMbuf class
 * Create: 2021-01-21
 */
#ifndef RTF_RAW_BUFFER_FOR_RAW_DATA_H
#define RTF_RAW_BUFFER_FOR_RAW_DATA_H

#include "rtf/com/types/ros_types.h"
#include "rtf/cm/type/mbuf_fwd.h"

namespace rtf {
namespace rtfbag {
class RawBufferForRawData {
public:
    rtf::com::ShapeShifter privateData;
    Mbuf* mbuf = nullptr;

    static bool IsPlane()
    {
        return false;
    }

    Mbuf* GetMbufPtr() const
    {
        return mbuf;
    }

    void SetMbufPtr(Mbuf *p)
    {
        mbuf = p;
    }

    using IsDpRawDataTag = void;
    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(privateData);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(privateData);
    }
}
;
}
}
#endif
