/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2012-2019. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_DDSEVENTINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_DDSEVENTINFO_H
#include "rtf/maintaind/dds/impl_type_vectortransportqos.h"
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint32_t.h"
#include "rtf/maintaind/dds/impl_type_durabilityqos.h"
#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/maintaind/dds/impl_type_historyqos.h"
#include "rtf/maintaind/impl_type_ddsattributemap.h"
#include "rtf/maintaind/dds/impl_type_schedulemode.h"
#include "rtf/maintaind/e2e/impl_type_e2econfiginfo.h"
#include "rtf/maintaind/dds/impl_type_reliabilitykind.h"
#include "rtf/stdtype/impl_type_boolean.h"
#include "rtf/basetype/impl_type_vectorstring.h"

namespace rtf {
namespace maintaind {
struct DDSEventInfo {
    ::rtf::stdtype::uint16_t serviceId_ {0U};
    ::rtf::stdtype::uint16_t instanceId_ {0U};
    ::rtf::stdtype::String networkIP_;
    ::rtf::stdtype::String subnetMask_;
    ::rtf::stdtype::uint16_t domainId_ {0U};
    ::rtf::stdtype::String topicName_;
    ::rtf::stdtype::String qosProfile_;
    ::rtf::stdtype::uint32_t entityId_ {0U};
    ::rtf::stdtype::uint32_t historyDepth_ {0U};
    ::rtf::maintaind::DurabilityQos durabilityQos_;
    ::rtf::maintaind::HistoryQos historyQos_;
    ::rtf::maintaind::VectorTransportQos transportQos_;
    ::rtf::stdtype::uint32_t fragSize_ {0U};
    ::rtf::stdtype::uint32_t listSize_ {0U};
    ::rtf::stdtype::String instanceShortName_;
    ::rtf::maintaind::DDSAttributeMap attribute_;
    ::rtf::maintaind::ScheduleMode scheduleMode_;
    ::rtf::maintaind::E2EConfigInfo e2eConfig_;
    ::rtf::maintaind::ReliabilityKind reliabilityKind_;
    ::rtf::stdtype::boolean enableDirectProcess_ {false};
    ::rtf::stdtype::boolean hugeMemory_ {false};
    bool enableIam_ {false};
    ara::core::String grantStr_;
    ara::core::String serviceGrantStr_;
    ::rtf::stdtype::uint32_t poolSize_ {0U};
    std::uint64_t privatePayloadOffset_ {0xFFFFFFFFU};
    ::rtf::stdtype::String udpMulticastAddr_;
    ::rtf::basetype::VectorString discoveryMulticastAddr_;
    ::rtf::stdtype::boolean isFSHMMulticast_ {false};
    ::rtf::stdtype::String fshmMulticastAddr_;
    static bool IsPlane() noexcept { return false; }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(domainId_);
        fun(topicName_);
        fun(qosProfile_);
        fun(entityId_);
        fun(historyDepth_);
        fun(durabilityQos_);
        fun(historyQos_);
        fun(transportQos_);
        fun(fragSize_);
        fun(listSize_);
        fun(instanceShortName_);
        fun(attribute_);
        fun(scheduleMode_);
        fun(e2eConfig_);
        fun(reliabilityKind_);
        fun(enableDirectProcess_);
        fun(hugeMemory_);
        fun(enableIam_);
        fun(grantStr_);
        fun(serviceGrantStr_);
        fun(poolSize_);
        fun(privatePayloadOffset_);
        fun(udpMulticastAddr_);
        fun(discoveryMulticastAddr_);
        fun(isFSHMMulticast_);
        fun(fshmMulticastAddr_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(domainId_);
        fun(topicName_);
        fun(qosProfile_);
        fun(entityId_);
        fun(historyDepth_);
        fun(durabilityQos_);
        fun(historyQos_);
        fun(transportQos_);
        fun(fragSize_);
        fun(listSize_);
        fun(instanceShortName_);
        fun(attribute_);
        fun(scheduleMode_);
        fun(e2eConfig_);
        fun(reliabilityKind_);
        fun(enableDirectProcess_);
        fun(hugeMemory_);
        fun(enableIam_);
        fun(grantStr_);
        fun(serviceGrantStr_);
        fun(poolSize_);
        fun(privatePayloadOffset_);
        fun(udpMulticastAddr_);
        fun(discoveryMulticastAddr_);
        fun(isFSHMMulticast_);
        fun(fshmMulticastAddr_);
    }

    friend bool operator == (
        const ::rtf::maintaind::DDSEventInfo& lhs, const ::rtf::maintaind::DDSEventInfo& rhs) noexcept
    {
        return ((lhs.serviceId_ == rhs.serviceId_) && (lhs.instanceId_ == rhs.instanceId_) &&
                (lhs.networkIP_ == rhs.networkIP_) && (lhs.subnetMask_ == rhs.subnetMask_) &&
                (lhs.domainId_ == rhs.domainId_) && (lhs.topicName_ == rhs.topicName_) &&
                (lhs.qosProfile_ == rhs.qosProfile_) && (lhs.entityId_ == rhs.entityId_) &&
                (lhs.historyDepth_ == rhs.historyDepth_) && (lhs.durabilityQos_ == rhs.durabilityQos_) &&
                (lhs.historyQos_ == rhs.historyQos_) && (lhs.transportQos_ == rhs.transportQos_) &&
                (lhs.fragSize_ == rhs.fragSize_) && (lhs.listSize_ == rhs.listSize_) &&
                (lhs.instanceShortName_ == rhs.instanceShortName_) && (lhs.attribute_ == rhs.attribute_) &&
                (lhs.scheduleMode_ == rhs.scheduleMode_) && (lhs.e2eConfig_ == rhs.e2eConfig_) &&
                (lhs.reliabilityKind_ == rhs.reliabilityKind_) &&
                (lhs.enableDirectProcess_ == rhs.enableDirectProcess_) && (lhs.hugeMemory_ == rhs.hugeMemory_) &&
                (lhs.enableIam_ == rhs.enableIam_) && (lhs.grantStr_ == rhs.grantStr_) &&
                (lhs.serviceGrantStr_ == rhs.serviceGrantStr_) && (lhs.poolSize_ == rhs.poolSize_) &&
                (lhs.privatePayloadOffset_ == rhs.privatePayloadOffset_) &&
                (lhs.udpMulticastAddr_ == rhs.udpMulticastAddr_) &&
                (lhs.discoveryMulticastAddr_ == rhs.discoveryMulticastAddr_) &&
                (lhs.isFSHMMulticast_ == rhs.isFSHMMulticast_) && (lhs.fshmMulticastAddr_ == rhs.fshmMulticastAddr_));
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_DDSEVENTINFO_H
