/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2023-2023. All rights reserved.
 * Generated by VRTF CM-Generator
 */


#ifndef RTFTOOLS_IMPL_TYPE_DDSFIELDINFO_H
#define RTFTOOLS_IMPL_TYPE_DDSFIELDINFO_H
#include "rtf/stdtype/impl_type_boolean.h"
#include "rtf/maintaind/impl_type_ddsnotifyInfo.h"
#include "rtf/maintaind/impl_type_ddssetgetInfo.h"
#include "rtf/maintaind/dds/impl_type_vectortransportqos.h"

namespace rtf {
namespace maintaind {
struct DDSFieldInfo {
    ::rtf::stdtype::uint16_t serviceId_ {0U};
    ::rtf::stdtype::uint16_t instanceId_ {0U};
    ::rtf::stdtype::uint16_t entityId_ {0U};
    ::rtf::stdtype::String fieldName_;
    ::rtf::stdtype::uint16_t domainId_ {0U};
    ::rtf::stdtype::String networkIP_;
    ::rtf::stdtype::String vlan_;       // only for export.json
    ::rtf::stdtype::String subnetMask_;
    ::rtf::stdtype::String instanceShortName_;
    ::rtf::stdtype::String serviceGrantStr_;
    ::rtf::maintaind::VectorTransportQos transportQos_;
    ::rtf::stdtype::boolean hasNotify_ {false};
    ::rtf::stdtype::boolean hasSetter_ {false};
    ::rtf::stdtype::boolean hasGetter_ {false};
    ::rtf::maintaind::DDSNotifyInfo notifyInfo_;
    ::rtf::maintaind::DDSSetGetInfo setterInfo_;
    ::rtf::maintaind::DDSSetGetInfo getterInfo_;

    static bool IsPlane() noexcept { return false; }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(entityId_);
        fun(fieldName_);
        fun(domainId_);
        fun(vlan_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(instanceShortName_);
        fun(serviceGrantStr_);
        fun(transportQos_);
        fun(hasNotify_);
        fun(hasSetter_);
        fun(hasGetter_);
        fun(notifyInfo_);
        fun(setterInfo_);
        fun(getterInfo_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(entityId_);
        fun(fieldName_);
        fun(domainId_);
        fun(vlan_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(instanceShortName_);
        fun(serviceGrantStr_);
        fun(transportQos_);
        fun(hasNotify_);
        fun(hasSetter_);
        fun(hasGetter_);
        fun(notifyInfo_);
        fun(setterInfo_);
        fun(getterInfo_);
    }

    friend bool operator == (
            const ::rtf::maintaind::DDSFieldInfo& lhs, const ::rtf::maintaind::DDSFieldInfo& rhs) noexcept
    {
        return std::tie(lhs.serviceId_, lhs.instanceId_, lhs.entityId_, lhs.fieldName_, lhs.domainId_, lhs.vlan_, lhs.networkIP_,
                        lhs.subnetMask_, lhs.instanceShortName_, lhs.serviceGrantStr_, lhs.transportQos_,
                        lhs.hasNotify_, lhs.hasSetter_, lhs.hasGetter_, lhs.notifyInfo_, lhs.setterInfo_, lhs.getterInfo_) ==
               std::tie(rhs.serviceId_, rhs.instanceId_, rhs.entityId_, rhs.fieldName_, rhs.domainId_, rhs.vlan_, rhs.networkIP_,
                        rhs.subnetMask_, rhs.instanceShortName_, rhs.serviceGrantStr_, rhs.transportQos_,
                        rhs.hasNotify_, rhs.hasSetter_, rhs.hasGetter_, rhs.notifyInfo_, rhs.setterInfo_, rhs.getterInfo_);
    }
};
} // namespace maintaind
} // namespace rtf
#endif //RTFTOOLS_IMPL_TYPE_DDSFIELDINFO_H
