/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_DDSMETHODINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_DDSMETHODINFO_H
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/stdtype/impl_type_uint32_t.h"
#include "rtf/maintaind/dds/impl_type_durabilityqos.h"
#include "rtf/maintaind/dds/impl_type_historyqos.h"
#include "rtf/maintaind/dds/impl_type_vectortransportqos.h"
#include "rtf/maintaind/e2e/impl_type_e2econfiginfo.h"
#include "rtf/maintaind/dds/impl_type_reliabilitykind.h"
#include "rtf/basetype/impl_type_vectorstring.h"

namespace rtf {
namespace maintaind {
struct DDSMethodInfo {
    ::rtf::stdtype::String methodName_;
    ::rtf::stdtype::String instanceShortName_;
    ::rtf::stdtype::String requestTopicName_;
    ::rtf::stdtype::String replyTopicName_;
    ::rtf::stdtype::String networkIP_;
    ::rtf::stdtype::String subnetMask_;
    ::rtf::stdtype::uint16_t domainId_ {0U};
    ::rtf::stdtype::uint32_t readerDepth_ {0U};
    ::rtf::stdtype::uint32_t writerDepth_ {0U};
    ::rtf::maintaind::DurabilityQos requestDurabilityQos_;
    ::rtf::maintaind::DurabilityQos replyDurabilityQos_;
    ::rtf::maintaind::HistoryQos requestHistoryQos_;
    ::rtf::maintaind::HistoryQos replyHistoryQos_;
    ::rtf::maintaind::VectorTransportQos transportQos_;
    ::rtf::stdtype::uint32_t requestFragSize_ {0U};
    ::rtf::stdtype::uint32_t requestListSize_ {0U};
    ::rtf::stdtype::uint32_t replyFragSize_ {0U};
    ::rtf::stdtype::uint32_t replyListSize_ {0U};
    ::rtf::maintaind::E2EConfigInfo e2eConfig_;
    ::rtf::maintaind::ReliabilityKind reliabilityKind_;
    bool enableIam_ {false};
    ara::core::String grantStr_;
    ara::core::String serviceGrantStr_;
    ::rtf::stdtype::uint32_t requestPoolSize_ {0U};
    ::rtf::stdtype::uint32_t replyPoolSize_ {0U};
    ::rtf::basetype::VectorString discoveryMulticastAddr_;
    static bool IsPlane() noexcept { return false; }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(methodName_);
        fun(instanceShortName_);
        fun(requestTopicName_);
        fun(replyTopicName_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(domainId_);
        fun(readerDepth_);
        fun(writerDepth_);
        fun(requestDurabilityQos_);
        fun(replyDurabilityQos_);
        fun(requestHistoryQos_);
        fun(replyHistoryQos_);
        fun(transportQos_);
        fun(requestFragSize_);
        fun(requestListSize_);
        fun(replyFragSize_);
        fun(replyListSize_);
        fun(e2eConfig_);
        fun(reliabilityKind_);
        fun(enableIam_);
        fun(grantStr_);
        fun(serviceGrantStr_);
        fun(requestPoolSize_);
        fun(replyPoolSize_);
        fun(discoveryMulticastAddr_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(methodName_);
        fun(instanceShortName_);
        fun(requestTopicName_);
        fun(replyTopicName_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(domainId_);
        fun(readerDepth_);
        fun(writerDepth_);
        fun(requestDurabilityQos_);
        fun(replyDurabilityQos_);
        fun(requestHistoryQos_);
        fun(replyHistoryQos_);
        fun(transportQos_);
        fun(requestFragSize_);
        fun(requestListSize_);
        fun(replyFragSize_);
        fun(replyListSize_);
        fun(e2eConfig_);
        fun(reliabilityKind_);
        fun(enableIam_);
        fun(grantStr_);
        fun(serviceGrantStr_);
        fun(requestPoolSize_);
        fun(replyPoolSize_);
        fun(discoveryMulticastAddr_);
    }


    friend bool operator == (
        const ::rtf::maintaind::DDSMethodInfo& lhs, const ::rtf::maintaind::DDSMethodInfo& rhs) noexcept
    {
        return ((lhs.methodName_ == rhs.methodName_) && (lhs.instanceShortName_ == rhs.instanceShortName_) &&
                (lhs.requestTopicName_ == rhs.requestTopicName_) && (lhs.replyTopicName_ == rhs.replyTopicName_) &&
                (lhs.networkIP_ == rhs.networkIP_) && (lhs.subnetMask_ == rhs.subnetMask_) &&
                (lhs.domainId_ == rhs.domainId_) && (lhs.readerDepth_ == rhs.readerDepth_) &&
                (lhs.writerDepth_ == rhs.writerDepth_) && (lhs.requestDurabilityQos_ == rhs.requestDurabilityQos_) &&
                (lhs.replyDurabilityQos_ == rhs.replyDurabilityQos_) &&
                (lhs.requestHistoryQos_ == rhs.requestHistoryQos_) && (lhs.replyHistoryQos_ == rhs.replyHistoryQos_) &&
                (lhs.transportQos_ == rhs.transportQos_) && (lhs.requestFragSize_ == rhs.requestFragSize_) &&
                (lhs.requestListSize_ == rhs.requestListSize_) && (lhs.replyFragSize_ == rhs.replyFragSize_) &&
                (lhs.replyListSize_ == rhs.replyListSize_) && (lhs.e2eConfig_ == rhs.e2eConfig_) &&
                (lhs.reliabilityKind_ == rhs.reliabilityKind_) && (lhs.enableIam_ == rhs.enableIam_) &&
                (lhs.grantStr_ == rhs.grantStr_) &&
                (lhs.serviceGrantStr_ == rhs.serviceGrantStr_) &&
                (lhs.requestPoolSize_ == rhs.requestPoolSize_) && (lhs.replyPoolSize_ == rhs.replyPoolSize_) &&
                (lhs.discoveryMulticastAddr_ == rhs.discoveryMulticastAddr_));
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_DDSMETHODINFO_H
