/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2022. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_LISTENERPARAMS_H
#define RTF_MAINTAIND_IMPL_TYPE_LISTENERPARAMS_H
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint32_t.h"
#include "rtf/stdtype/impl_type_int32_t.h"

namespace rtf {
namespace maintaind {
struct ListenerParams {
    ::rtf::stdtype::String   guid_;
    ::rtf::stdtype::uint32_t pubPid_ {0U};
    ::rtf::stdtype::uint32_t subPid_ {0U};
    ::rtf::stdtype::int32_t appPid_ {0};

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(guid_);
        fun(pubPid_);
        fun(subPid_);
        fun(appPid_);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(guid_);
        fun(pubPid_);
        fun(subPid_);
        fun(appPid_);
    }

    bool operator==(const ::rtf::maintaind::ListenerParams& t) const
    {
        return (guid_ == t.guid_) && (pubPid_ == t.pubPid_) && (subPid_ == t.subPid_) && (appPid_ == t.appPid_);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_LISTENERPARAMS_H
