/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2023. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_METHODINFOWITHPUBSUB_H
#define RTF_MAINTAIND_IMPL_TYPE_METHODINFOWITHPUBSUB_H

#include "rtf/maintaind/impl_type_methodregisterinfo.h"
#include "rtf/basetype/impl_type_vectorstring.h"
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_boolean.h"

namespace rtf {
namespace maintaind {
struct MethodInfoWithPubSub {
    ::rtf::maintaind::MethodRegisterInfo methodInfo;
    ::rtf::basetype::VectorString subs;
    ::rtf::stdtype::String pub;
    ::rtf::stdtype::boolean pubOnLine {false};
    ::rtf::stdtype::String uuid;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(methodInfo);
        fun(subs);
        fun(pub);
        fun(pubOnLine);
        fun(uuid);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(methodInfo);
        fun(subs);
        fun(pub);
        fun(pubOnLine);
        fun(uuid);
    }

    friend bool operator==(const ::rtf::maintaind::MethodInfoWithPubSub& lhs, const ::rtf::maintaind::MethodInfoWithPubSub& rhs) noexcept
    {
        return (lhs.methodInfo == rhs.methodInfo) && (lhs.subs == rhs.subs) && (lhs.pub == rhs.pub) && (lhs.pubOnLine == rhs.pubOnLine) && (lhs.uuid == rhs.uuid);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_METHODINFOWITHPUBSUB_H
