/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2021. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_METHODREGISTERINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_METHODREGISTERINFO_H
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/maintaind/impl_type_methodmap.h"
#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/basetype/impl_type_vectorstring.h"
#include "rtf/stdtype/impl_type_int32_t.h"
#include "rtf/maintaind/impl_type_serializeconfig.h"
#include "rtf/maintaind/impl_type_vectorerrordomain.h"

namespace rtf {
namespace maintaind {
struct MethodRegisterInfo {
    ::rtf::stdtype::String appName_;
    ::rtf::stdtype::String methodType_;
    ::rtf::maintaind::MethodMap methodMap_;
    ::rtf::stdtype::uint16_t instanceId_ {0U};
    ::rtf::stdtype::uint16_t serviceId_ {0U};
    ::rtf::basetype::VectorString inputParameterList_;
    ::rtf::basetype::VectorString outputParameterList_;
    ::rtf::stdtype::int32_t nodePid_ {0};
    ::rtf::maintaind::SerializeConfig requestSerializeConfig_;
    ::rtf::maintaind::SerializeConfig replySerializeConfig_;
    ::rtf::stdtype::String outputName_;
    ::rtf::stdtype::String inputName_;
    ::rtf::maintaind::VectorErrorDomain errors_;
    ::rtf::stdtype::String domainName_;
    bool isFireAndForget_ {false};
    bool isOnline_ {false};
    std::string instanceHandle_;
    ::rtf::stdtype::String serviceName_;

    static bool IsPlane() noexcept
    {
        return false;
    }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(appName_);
        fun(methodType_);
        fun(methodMap_);
        fun(instanceId_);
        fun(serviceId_);
        fun(inputParameterList_);
        fun(outputParameterList_);
        fun(nodePid_);
        fun(requestSerializeConfig_);
        fun(replySerializeConfig_);
        fun(outputName_);
        fun(inputName_);
        fun(errors_);
        fun(domainName_);
        fun(isFireAndForget_);
        fun(isOnline_);
        fun(instanceHandle_);
        fun(serviceName_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(appName_);
        fun(methodType_);
        fun(methodMap_);
        fun(instanceId_);
        fun(serviceId_);
        fun(inputParameterList_);
        fun(outputParameterList_);
        fun(nodePid_);
        fun(requestSerializeConfig_);
        fun(replySerializeConfig_);
        fun(outputName_);
        fun(inputName_);
        fun(errors_);
        fun(domainName_);
        fun(isFireAndForget_);
        fun(isOnline_);
        fun(instanceHandle_);
        fun(serviceName_);
    }
    friend bool operator == (
        const ::rtf::maintaind::MethodRegisterInfo& lhs, const ::rtf::maintaind::MethodRegisterInfo& rhs) noexcept
    {
        return ((lhs.appName_ == rhs.appName_) && (lhs.methodType_ == rhs.methodType_) &&
               (lhs.methodMap_ == rhs.methodMap_) && (lhs.instanceId_ == rhs.instanceId_) &&
               (lhs.serviceId_ == rhs.serviceId_) &&
               (lhs.inputParameterList_ == rhs.inputParameterList_) &&
               (lhs.outputParameterList_ == rhs.outputParameterList_) &&
               (lhs.nodePid_ == rhs.nodePid_) &&
               (lhs.requestSerializeConfig_ == rhs.requestSerializeConfig_) &&
               (lhs.replySerializeConfig_ == rhs.replySerializeConfig_) &&
               (lhs.outputName_ == rhs.outputName_) && (lhs.inputName_ == rhs.inputName_) && (lhs.errors_ == rhs.errors_) &&
               (lhs.domainName_ == rhs.domainName_) &&
               (lhs.isFireAndForget_ == rhs.isFireAndForget_) && (lhs.isOnline_ == rhs.isOnline_) &&
               (lhs.instanceHandle_ == rhs.instanceHandle_) && (lhs.serviceName_ == rhs.serviceName_));
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_METHODREGISTERINFO_H
