/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_NODEENTITYINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_NODEENTITYINFO_H
#include "rtf/stdtype/impl_type_string.h"

namespace rtf {
namespace maintaind {
struct NodeEntityInfo {
    ::rtf::stdtype::String   name_;
    ::rtf::stdtype::String   uuid_;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(name_);
        fun(uuid_);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(name_);
        fun(uuid_);
    }

    bool operator==(const ::rtf::maintaind::NodeEntityInfo& t) const
    {
        return (name_ == t.name_) && (uuid_ == t.uuid_);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_NODEENTITYINFO_H
