/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2023. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_PEERENDPOINT_H
#define RTF_MAINTAIND_IMPL_TYPE_PEERENDPOINT_H

#include "rtf/maintaind/impl_type_peerunicastvec.h"
#include "rtf/maintaind/impl_type_peermulticastvec.h"

namespace rtf {
namespace maintaind {
struct PeerEndpoint {
    ::rtf::maintaind::PeerUnicastVec unicasts;
    ::rtf::maintaind::PeerMulticastVec multicasts;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(unicasts);
        fun(multicasts);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(unicasts);
        fun(multicasts);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("unicasts", unicasts);
        fun("multicasts", multicasts);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("unicasts", unicasts);
        fun("multicasts", multicasts);
    }

    friend bool operator==(const ::rtf::maintaind::PeerEndpoint& lhs, const ::rtf::maintaind::PeerEndpoint& rhs) noexcept
    {
        return (lhs.unicasts == rhs.unicasts) && (lhs.multicasts == rhs.multicasts);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_PEERENDPOINT_H
