/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2023. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_PEERMULTICAST_H
#define RTF_MAINTAIND_IMPL_TYPE_PEERMULTICAST_H

#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/stdtype/impl_type_string.h"

namespace rtf {
namespace maintaind {
struct PeerMulticast {
    ::uint16_t grpId {0U};
    rtf::stdtype::String ip;
    ::uint16_t port {65535U};

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(grpId);
        fun(ip);
        fun(port);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(grpId);
        fun(ip);
        fun(port);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("grpId", grpId);
        fun("ip", ip);
        fun("port", port);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("grpId", grpId);
        fun("ip", ip);
        fun("port", port);
    }

    friend bool operator==(const ::rtf::maintaind::PeerMulticast& lhs, const ::rtf::maintaind::PeerMulticast& rhs) noexcept
    {
        return (lhs.grpId == rhs.grpId) && (lhs.ip == rhs.ip) && (lhs.port == rhs.port);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_PEERMULTICAST_H
