/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2023. All rights reserved.
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_PEERUNICAST_H
#define RTF_MAINTAIND_IMPL_TYPE_PEERUNICAST_H

#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint16_t.h"

namespace rtf {
namespace maintaind {
struct PeerUnicast {
    rtf::stdtype::String ip;
    ::uint16_t reliable {65535U};
    ::uint16_t unreliable {65535U};

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ip);
        fun(reliable);
        fun(unreliable);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ip);
        fun(reliable);
        fun(unreliable);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ip", ip);
        fun("reliable", reliable);
        fun("unreliable", unreliable);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ip", ip);
        fun("reliable", reliable);
        fun("unreliable", unreliable);
    }

    friend bool operator==(const ::rtf::maintaind::PeerUnicast& lhs, const ::rtf::maintaind::PeerUnicast& rhs) noexcept
    {
        return (lhs.ip == rhs.ip) && (lhs.reliable == rhs.reliable) && (lhs.unreliable == rhs.unreliable);
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_PEERUNICAST_H
