/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2023-2023. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_SERVICEREGISTERINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_SERVICEREGISTERINFO_H
#include "rtf/maintaind/impl_type_drivertype.h"
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_int32_t.h"
#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/stdtype/impl_type_boolean.h"
#include "rtf/maintaind/dds/impl_type_vectortransportqos.h"

namespace rtf {
namespace maintaind {
struct ServiceRegisterInfo {
    rtf::stdtype::String serviceName_;
    rtf::stdtype::String instanceShortName_;
    rtf::stdtype::String appName_;
    rtf::stdtype::uint16_t serviceId_ {0U};
    rtf::stdtype::uint16_t instanceId_ {0U};
    rtf::stdtype::String networkIP_;
    rtf::stdtype::String subnetMask_;
    rtf::maintaind::DriverType driverType_;
    rtf::stdtype::uint16_t domainId_ {0U};
    rtf::stdtype::String instanceHandle_;
    rtf::stdtype::int32_t nodePid_ {0};
    rtf::stdtype::String serviceGrantStr_;
    ara::core::Vector<rtf::maintaind::TransportQos> transportQos_;
    rtf::stdtype::boolean isReliable_ {false};
    static bool IsPlane() noexcept { return false; }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(serviceName_);
        fun(instanceShortName_);
        fun(appName_);
        fun(serviceId_);
        fun(instanceId_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(driverType_);
        fun(domainId_);
        fun(instanceHandle_);
        fun(nodePid_);
        fun(serviceGrantStr_);
        fun(transportQos_);
        fun(isReliable_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(serviceName_);
        fun(instanceShortName_);
        fun(appName_);
        fun(serviceId_);
        fun(instanceId_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(driverType_);
        fun(domainId_);
        fun(instanceHandle_);
        fun(nodePid_);
        fun(serviceGrantStr_);
        fun(transportQos_);
        fun(isReliable_);
    }

    friend bool operator == (
        const ::rtf::maintaind::ServiceRegisterInfo& lhs, const ::rtf::maintaind::ServiceRegisterInfo& rhs) noexcept
    {
        return ((lhs.serviceName_ == rhs.serviceName_) && (lhs.instanceShortName_ == rhs.instanceShortName_) &&
                (lhs.appName_ == rhs.appName_) && (lhs.serviceId_ == rhs.serviceId_) &&
                (lhs.instanceId_ == rhs.instanceId_) && (lhs.networkIP_ == rhs.networkIP_) &&
                (lhs.subnetMask_ == rhs.subnetMask_) && (lhs.driverType_ == rhs.driverType_) &&
                (lhs.domainId_ == rhs.domainId_) &&
                (lhs.instanceHandle_ == rhs.instanceHandle_) && (lhs.nodePid_ == rhs.nodePid_) &&
                (lhs.serviceGrantStr_ == rhs.serviceGrantStr_) && (lhs.transportQos_ == rhs.transportQos_) &&
                (lhs.isReliable_ == rhs.isReliable_));
    }
};
} // namespace maintaind
} // namespace rtf


#endif // RTF_MAINTAIND_IMPL_TYPE_SERVICEREGISTERINFO_H
