/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2023-2023. All rights reserved.
 * Generated by VRTF CM-Generator
 */


#ifndef RTFTOOLS_IMPL_TYPE_SOMEIPFIELDINFO_H
#define RTFTOOLS_IMPL_TYPE_SOMEIPFIELDINFO_H
#include "rtf/stdtype/impl_type_boolean.h"
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/basetype/impl_type_vectoruint16.h"
#include "rtf/stdtype/impl_type_uint32_t.h"
#include "rtf/stdtype/impl_type_uint16_t.h"
#include "rtf/maintaind/impl_type_someipnotifyInfo.h"
#include "rtf/maintaind/impl_type_someipsetgetInfo.h"
#include "rtf/maintaind/serialize/impl_type_serializeconfigrawdata.h"

namespace rtf {
namespace maintaind {
struct SomeipFieldInfo {
    ::rtf::stdtype::uint16_t serviceId_;
    ::rtf::stdtype::uint16_t instanceId_;
    ::rtf::stdtype::String vlan_;       // only for export.json
    ::rtf::stdtype::String networkIP_;
    ::rtf::stdtype::String subnetMask_;
    ::rtf::stdtype::String someipNetwork_;
    ::rtf::stdtype::String fieldName_;
    ::rtf::stdtype::String instanceShortName_;
    ::rtf::stdtype::boolean isReliable_ {false};
    ::rtf::stdtype::uint32_t minorVersion_ {0U};
    ::rtf::stdtype::uint16_t majorVersion_ {0U};
    ara::core::String serviceGrantStr_;
    bool enableIam_ {false};
    ::rtf::stdtype::boolean hasNotify_ {false};
    ::rtf::stdtype::boolean hasSetter_ {false};
    ::rtf::stdtype::boolean hasGetter_ {false};
    ::rtf::maintaind::SomeipNotifyInfo notifyInfo_;
    ::rtf::maintaind::SomeipSetGetInfo setterInfo_;
    ::rtf::maintaind::SomeipSetGetInfo getterInfo_;
    ::rtf::maintaind::SerializeConfigRawData serializeConfig_;

    static bool IsPlane() noexcept
    {
        return false;
    }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(vlan_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(someipNetwork_);
        fun(fieldName_);
        fun(instanceShortName_);
        fun(isReliable_);
        fun(minorVersion_);
        fun(majorVersion_);
        fun(serviceGrantStr_);
        fun(enableIam_);
        fun(hasNotify_);
        fun(hasSetter_);
        fun(hasGetter_);
        fun(notifyInfo_);
        fun(setterInfo_);
        fun(getterInfo_);
        fun(serializeConfig_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(serviceId_);
        fun(instanceId_);
        fun(vlan_);
        fun(networkIP_);
        fun(subnetMask_);
        fun(someipNetwork_);
        fun(fieldName_);
        fun(instanceShortName_);
        fun(isReliable_);
        fun(minorVersion_);
        fun(majorVersion_);
        fun(serviceGrantStr_);
        fun(enableIam_);
        fun(hasNotify_);
        fun(hasSetter_);
        fun(hasGetter_);
        fun(notifyInfo_);
        fun(setterInfo_);
        fun(getterInfo_);
        fun(serializeConfig_);
    }

    friend bool operator == (
            const ::rtf::maintaind::SomeipFieldInfo& lhs, const ::rtf::maintaind::SomeipFieldInfo& rhs) noexcept
    {
        return std::tie(lhs.serviceId_, lhs.instanceId_, lhs.vlan_, lhs.networkIP_, lhs.subnetMask_, lhs.someipNetwork_, lhs.fieldName_,
                 lhs.instanceShortName_, lhs.isReliable_, lhs.minorVersion_, lhs.majorVersion_, lhs.serviceGrantStr_, lhs.enableIam_,
                 lhs.hasNotify_, lhs.hasSetter_, lhs.hasGetter_, lhs.notifyInfo_, lhs.setterInfo_, lhs.getterInfo_, lhs.serializeConfig_) ==
                std::tie(rhs.serviceId_, rhs.instanceId_, rhs.vlan_, rhs.networkIP_, rhs.subnetMask_, rhs.someipNetwork_, rhs.fieldName_,
                 rhs.instanceShortName_, rhs.isReliable_, rhs.minorVersion_, rhs.majorVersion_, rhs.serviceGrantStr_, rhs.enableIam_,
                 rhs.hasNotify_, rhs.hasSetter_, rhs.hasGetter_, rhs.notifyInfo_, rhs.setterInfo_, rhs.getterInfo_, rhs.serializeConfig_);
    }
};
} // namespace maintaind
} // namespace rtf
#endif //RTFTOOLS_IMPL_TYPE_SOMEIPFIELDINFO_H
