/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 * Description: This provide the data structure to store isignal info.
 * Create: 2022-03-30
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_ISIGNALINFO_H
#define RTF_MAINTAIND_IMPL_TYPE_ISIGNALINFO_H
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint64_t.h"
#include "rtf/stdtype/impl_type_boolean.h"
namespace rtf {
namespace maintaind {
struct IsignalInfo {
    ::rtf::stdtype::String isignalName_;
    ::rtf::stdtype::String type_;
    ::rtf::stdtype::boolean isDynamic_ {false};
    ::rtf::stdtype::uint64_t startPos_ {0U};
    ::rtf::stdtype::uint64_t length_ {0U};
    ::rtf::stdtype::String byteOrder_;

    static bool IsPlane() noexcept
    {
        return false;
    }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(isignalName_);
        fun(type_);
        fun(isDynamic_);
        fun(startPos_);
        fun(length_);
        fun(byteOrder_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(isignalName_);
        fun(type_);
        fun(isDynamic_);
        fun(startPos_);
        fun(length_);
        fun(byteOrder_);
    }

    friend bool operator == (
        const ::rtf::maintaind::IsignalInfo& lhs, const ::rtf::maintaind::IsignalInfo& rhs) noexcept
    {
        return ((lhs.isignalName_ == rhs.isignalName_) && (lhs.type_ == rhs.type_) &&
        (lhs.isDynamic_ == rhs.isDynamic_) &&
        (lhs.startPos_ == rhs.startPos_) && (lhs.length_ == rhs.length_) && (lhs.byteOrder_ == rhs.byteOrder_));
    }
};
} // namespace maintaind
} // namespace rtf

#endif // RTF_MAINTAIND_IMPL_TYPE_ISIGNALINFO_H
