/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 * Description: This provide the data structure to store pdu info.
 * Create: 2022-03-29
 */

#ifndef RTF_MAINTAIND_IMPL_TYPE_PDUCONFIG_H
#define RTF_MAINTAIND_IMPL_TYPE_PDUCONFIG_H
#include "rtf/stdtype/impl_type_string.h"
#include "rtf/stdtype/impl_type_uint64_t.h"
#include "rtf/stdtype/impl_type_int16_t.h"
#include "rtf/stdtype/impl_type_boolean.h"
#include "rtf/maintaind/pdu/impl_type_isignalinfovector.h"
namespace rtf {
namespace maintaind {
struct PduConfigInfo {
    ::rtf::stdtype::String pduName_;
    ::rtf::stdtype::uint64_t length_ {0U};
    ::rtf::stdtype::boolean isDynamic_ {false};
    ::rtf::stdtype::boolean enableTruncation_ {false};
    ::rtf::stdtype::int16_t lengthDeviation_ {0};
    ::rtf::maintaind::IsignalInfoVector isignalInfoList_;

    static bool IsPlane() noexcept
    {
        return false;
    }

    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun) noexcept
    {
        fun(pduName_);
        fun(length_);
        fun(isDynamic_);
        fun(enableTruncation_);
        fun(lengthDeviation_);
        fun(isignalInfoList_);
    }

    template<typename F>
    void enumerate(F& fun) const noexcept
    {
        fun(pduName_);
        fun(length_);
        fun(isDynamic_);
        fun(enableTruncation_);
        fun(lengthDeviation_);
        fun(isignalInfoList_);
    }

    friend bool operator == (
        const ::rtf::maintaind::PduConfigInfo& lhs, const ::rtf::maintaind::PduConfigInfo& rhs) noexcept
    {
        return ((lhs.pduName_ == rhs.pduName_) && (lhs.length_ == rhs.length_) &&
        (lhs.isDynamic_ == rhs.isDynamic_) && (lhs.enableTruncation_ == rhs.enableTruncation_) &&
        (lhs.lengthDeviation_ == rhs.lengthDeviation_) && (lhs.isignalInfoList_ == rhs.isignalInfoList_));
    }
};
} // namespace maintaind
} // namespace rtf

#endif // RTF_MAINTAIND_IMPL_TYPE_PDUCONFIG_H
