/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_RTFMAINTAINDAPPSERVICE_SKELETON_H
#define RTF_MAINTAIND_RTFMAINTAINDAPPSERVICE_SKELETON_H

#include "ara/com/internal/skeleton/skeleton_adapter.h"
#include "ara/com/internal/skeleton/event_adapter.h"
#include "ara/com/internal/skeleton/field_adapter.h"
#include "ara/com/internal/skeleton/method_adapter.h"
#include "rtf/maintaind/rtfmaintaindappservice_common.h"
#include "rtf/maintaind/latency/impl_type_latencyswitch.h"
#include <cstdint>

namespace rtf {
namespace maintaind {
namespace skeleton {
namespace events {
    using SwitchApplicationLatency = ara::com::internal::skeleton::event::EventAdapter<::rtf::maintaind::LatencySwitch>;
    // SwitchApplicationLatency_event_hash
    constexpr ara::com::internal::EntityId SwitchApplicationLatencyId = 30161U;
}

namespace methods {
    using RegisterAppInfoHandle = ara::com::internal::skeleton::method::MethodAdapter;
    constexpr ara::com::internal::EntityId RegisterAppInfoId = 60621U;
}

namespace fields {
}

class RTFMaintaindAppServiceSkeleton {
private:
    std::unique_ptr<ara::com::internal::skeleton::SkeletonAdapter> skeletonAdapter;
    void ConstructSkeleton(ara::com::MethodCallProcessingMode mode)
    {
        if (mode == ara::com::MethodCallProcessingMode::kEvent) {
            constexpr std::uint16_t threadNum {8U};
            constexpr std::uint16_t taskNum {512U};
            if (!(skeletonAdapter->SetMethodThreadNumber(skeletonAdapter->GetMethodThreadNumber(threadNum), taskNum))) {
                ara::core::ErrorCode errorCode(ara::com::ComErrc::kNetworkBindingFailure);
                throw ara::com::ComException(std::move(errorCode));
            }
        }
        const ara::core::Result<void> switchApplicationLatencyResult {SwitchApplicationLatency.Initialize()};
        ThrowError(switchApplicationLatencyResult);
        const ara::core::Result<void> RegisterAppInfoHandleResult {
            RegisterAppInfoHandle.Initialize<ara::core::Future<RegisterAppInfoOutput>>()};
        ThrowError(RegisterAppInfoHandleResult);
    }
    static void ThrowError(const ara::core::Result<void>& result)
    {
        if (!(result.HasValue())) {
            ara::core::ErrorCode errorCode {result.Error()};
            throw ara::com::ComException(std::move(errorCode));
        }
    }
public:
    struct RegisterAppInfoOutput {
        ::rtf::maintaind::ReturnCode result;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(result);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(result);
        }

        friend bool operator == (const RegisterAppInfoOutput lhs, const RegisterAppInfoOutput rhs) noexcept
        {
            return (lhs.result == rhs.result);
        }
    };

    struct RegisterNodePidInfoOutput {
        ::rtf::maintaind::ReturnCode result;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(result);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(result);
        }

        friend bool operator == (const RegisterNodePidInfoOutput lhs, const RegisterNodePidInfoOutput rhs) noexcept
        {
            return (lhs.result == rhs.result);
        }
    };

    struct UnregisterMethodInfoOutput {
        ::rtf::maintaind::ReturnCode result;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(result);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(result);
        }

        friend bool operator == (const UnregisterMethodInfoOutput lhs, const UnregisterMethodInfoOutput rhs) noexcept
        {
            return (lhs.result == rhs.result);
        }
    };

    explicit RTFMaintaindAppServiceSkeleton(const ara::com::InstanceIdentifier& instanceId,
                           ara::com::MethodCallProcessingMode mode = ara::com::MethodCallProcessingMode::kEvent)
        : skeletonAdapter(std::make_unique<ara::com::internal::skeleton::SkeletonAdapter>(
            ::rtf::maintaind::RTFMaintaindAppService::ServiceIdentifier, instanceId, mode)),
          SwitchApplicationLatency(skeletonAdapter->GetSkeleton(), events::SwitchApplicationLatencyId,
                                   ::rtf::maintaind::RTFMaintaindAppService::ServiceIdentifier, instanceId),
          RegisterAppInfoHandle(skeletonAdapter->GetSkeleton(), methods::RegisterAppInfoId,
                                ::rtf::maintaind::RTFMaintaindAppService::ServiceIdentifier, instanceId, mode)
    {
        ConstructSkeleton(mode);
    }

    RTFMaintaindAppServiceSkeleton(const RTFMaintaindAppServiceSkeleton&) = delete;
    RTFMaintaindAppServiceSkeleton& operator=(const RTFMaintaindAppServiceSkeleton&) & = delete;

    virtual ~RTFMaintaindAppServiceSkeleton() noexcept
    {
        StopOfferService();
    }

    void OfferService()
    {
        skeletonAdapter->RegisterClientChangedHandler(methods::RegisterAppInfoId,
            [this](const std::vector<std::string>& instanceHandleVec) {
                this->CleanInvalidClientHandle(instanceHandleVec);
            });

        skeletonAdapter->RegisterMethod(&RTFMaintaindAppServiceSkeleton::RegisterAppInfo,
            *this, methods::RegisterAppInfoId);
        skeletonAdapter->OfferService();
    }
    void StopOfferService() const noexcept
    {
        skeletonAdapter->StopOfferService();
    }
    ara::core::Future<bool> ProcessNextMethodCall() const
    {
        return skeletonAdapter->ProcessNextMethodCall();
    }
    bool SetMethodThreadNumber(const std::uint16_t number, const std::uint16_t queueSize) const
    {
        return skeletonAdapter->SetMethodThreadNumber(number, queueSize);
    }
    std::string GetClientInstanceHandle() const
    {
        return RegisterAppInfoHandle.GetClientInfo().GetClientName();
    }

    virtual ara::core::Future<RegisterAppInfoOutput> RegisterAppInfo(
        const ::rtf::maintaind::AppRegisterInfo& appInfo) = 0;
    virtual void CleanInvalidClientHandle(
        const std::vector<std::string>& instanceHandleVec) = 0;

    events::SwitchApplicationLatency SwitchApplicationLatency;
    methods::RegisterAppInfoHandle RegisterAppInfoHandle;
protected:
    RTFMaintaindAppServiceSkeleton(RTFMaintaindAppServiceSkeleton&& other) = default;
    RTFMaintaindAppServiceSkeleton& operator=(RTFMaintaindAppServiceSkeleton&& other) & = default;
};
} // namespace skeleton
} // namespace maintaind
} // namespace rtf

#endif // RTF_MAINTAIND_RTFMAINTAINDAPPSERVICE_SKELETON_H
