/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_PROXY_H
#define RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_PROXY_H

#include "rtf/maintaind/rtfmaintaindtoolsservice_proxy_common.h"

namespace rtf {
namespace maintaind {
namespace proxy {
class RTFMaintaindToolsServiceProxy {
private:
	std::unique_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
public:
    using HandleType = rtf::cm::type::HandleType;

    virtual ~RTFMaintaindToolsServiceProxy() = default;

    explicit RTFMaintaindToolsServiceProxy(const rtf::cm::type::HandleType &handle)
        : proxyAdapter(std::make_unique<ara::com::internal::proxy::ProxyAdapter>(
            ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, handle)),
          QueryAllDataType(proxyAdapter->GetProxy(), methods::QueryAllDataTypeId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryDataType(proxyAdapter->GetProxy(), methods::QueryDataTypeId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryDataTypeRefList(proxyAdapter->GetProxy(), methods::QueryDataTypeRefListId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryEventInfo(proxyAdapter->GetProxy(), methods::QueryEventInfoId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryEventShow(proxyAdapter->GetProxy(), methods::QueryEventShowId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryLatencyResult(proxyAdapter->GetProxy(), methods::QueryLatencyResultId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryLatencyStatus(proxyAdapter->GetProxy(), methods::QueryLatencyStatusId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryMethodInfo(proxyAdapter->GetProxy(), methods::QueryMethodInfoId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryMethodType(proxyAdapter->GetProxy(), methods::QueryMethodTypeId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryNodeInfo(proxyAdapter->GetProxy(), methods::QueryNodeInfoId, proxyAdapter->GetServiceInterfaceInfo()),
          QuerySubNodeEventInfo(proxyAdapter->GetProxy(), methods::QuerySubNodeEventInfoId, proxyAdapter->GetServiceInterfaceInfo()),
          SwitchLatencyMode(proxyAdapter->GetProxy(), methods::SwitchLatencyModeId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryServiceInfo(proxyAdapter->GetProxy(), methods::QueryServiceInfoId, proxyAdapter->GetServiceInterfaceInfo()),
          QueryFieldInfo(proxyAdapter->GetProxy(), methods::QueryFieldInfoId, proxyAdapter->GetServiceInterfaceInfo()) {
            bool result = true;
            result = result && (QueryAllDataType.GetMethodAdapter()->Initialize());
            result = result && (QueryDataType.GetMethodAdapter()->Initialize());
            result = result && (QueryDataTypeRefList.GetMethodAdapter()->Initialize());
            result = result && (QueryEventInfo.GetMethodAdapter()->Initialize());
            result = result && (QueryEventShow.GetMethodAdapter()->Initialize());
            result = result && (QueryLatencyResult.GetMethodAdapter()->Initialize());
            result = result && (QueryLatencyStatus.GetMethodAdapter()->Initialize());
            result = result && (QueryMethodInfo.GetMethodAdapter()->Initialize());
            result = result && (QueryMethodType.GetMethodAdapter()->Initialize());
            result = result && (QueryNodeInfo.GetMethodAdapter()->Initialize());
            result = result && (QuerySubNodeEventInfo.GetMethodAdapter()->Initialize());
            result = result && (SwitchLatencyMode.GetMethodAdapter()->Initialize());
            result = result && (QueryServiceInfo.GetMethodAdapter()->Initialize());
            result = result && (QueryFieldInfo.GetMethodAdapter()->Initialize());
            if (result == false) {
                ara::core::ErrorCode errorcode {ara::com::ComErrc::kNetworkBindingFailure};
                throw ara::com::ComException(std::move(errorcode));
            }
        }

    RTFMaintaindToolsServiceProxy(const RTFMaintaindToolsServiceProxy&) = delete;
    RTFMaintaindToolsServiceProxy& operator=(const RTFMaintaindToolsServiceProxy&) & = delete;

    RTFMaintaindToolsServiceProxy(RTFMaintaindToolsServiceProxy&& other) = default;
    RTFMaintaindToolsServiceProxy& operator=(RTFMaintaindToolsServiceProxy&& other) & = default;

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::com::InstanceIdentifier& instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(
            handler, ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instance);
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::core::InstanceSpecifier& specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(
            handler, ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, specifier);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::com::InstanceIdentifier& instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(
            ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instance);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::core::InstanceSpecifier& specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(
            ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, specifier);
    }

    static void StopFindService(const ara::com::FindServiceHandle handle)
    {
        ara::com::internal::proxy::ProxyAdapter::StopFindService(handle);
    }

    HandleType GetHandle() const noexcept
    {
        return proxyAdapter->GetHandle();
    }
    methods::QueryAllDataType QueryAllDataType;
    methods::QueryDataType QueryDataType;
    methods::QueryDataTypeRefList QueryDataTypeRefList;
    methods::QueryEventInfo QueryEventInfo;
    methods::QueryEventShow QueryEventShow;
    methods::QueryLatencyResult QueryLatencyResult;
    methods::QueryLatencyStatus QueryLatencyStatus;
    methods::QueryMethodInfo QueryMethodInfo;
    methods::QueryMethodType QueryMethodType;
    methods::QueryNodeInfo QueryNodeInfo;
    methods::QuerySubNodeEventInfo QuerySubNodeEventInfo;
    methods::SwitchLatencyMode SwitchLatencyMode;
    methods::QueryServiceInfo QueryServiceInfo;
    methods::QueryFieldInfo QueryFieldInfo;
};
} // namespace proxy
} // namespace maintaind
} // namespace rtf

#endif // RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_PROXY_H
