/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Generated by VRTF CM-Generator
 */

#ifndef RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_SKELETON_H
#define RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_SKELETON_H

#include "ara/com/internal/skeleton/skeleton_adapter.h"
#include "ara/com/internal/skeleton/event_adapter.h"
#include "ara/com/internal/skeleton/field_adapter.h"
#include "ara/com/internal/skeleton/method_adapter.h"
#include "rtf/maintaind/rtfmaintaindtoolsservice_common.h"
#include "rtf/maintaind/rtfmaintaindtoolsservice_skeleton_common.h"
#include "rtf/maintaind/impl_type_queryfieldinforeturntype.h"
#include <cstdint>
#include <cmath>

namespace rtf {
namespace maintaind {
namespace skeleton {
class RTFMaintaindToolsServiceSkeleton {
private:
    std::unique_ptr<ara::com::internal::skeleton::SkeletonAdapter> skeletonAdapter;
    void ConstructSkeleton(ara::com::MethodCallProcessingMode mode)
    {
        if (mode == ara::com::MethodCallProcessingMode::kEvent) {
            constexpr std::uint16_t threadNum {8U};
            constexpr std::uint16_t taskNum {512U};
            if (!(skeletonAdapter->SetMethodThreadNumber(skeletonAdapter->GetMethodThreadNumber(threadNum), taskNum))) {
                ara::core::ErrorCode errorCode(ara::com::ComErrc::kNetworkBindingFailure);
                throw ara::com::ComException(std::move(errorCode));
            }
        }
        const ara::core::Result<void> QueryAllDataTypeResult {
            QueryAllDataTypeHandle.Initialize<ara::core::Future<QueryAllDataTypeOutput>>()};
        ThrowError(QueryAllDataTypeResult);
        const ara::core::Result<void> QueryDataTypeResult {
            QueryDataTypeHandle.Initialize<ara::core::Future<QueryDataTypeOutput>>()};
        ThrowError(QueryDataTypeResult);
        const ara::core::Result<void> QueryDataTypeRefListResult {
            QueryDataTypeRefListHandle.Initialize<ara::core::Future<QueryDataTypeRefListOutput>>()};
        ThrowError(QueryDataTypeRefListResult);
        const ara::core::Result<void> QueryEventInfoResult {
            QueryEventInfoHandle.Initialize<ara::core::Future<QueryEventInfoOutput>>()};
        ThrowError(QueryEventInfoResult);
        const ara::core::Result<void> QueryEventShowResult {
            QueryEventShowHandle.Initialize<ara::core::Future<QueryEventShowOutput>>()};
        ThrowError(QueryEventShowResult);
        const ara::core::Result<void> QueryLatencyResultResult {
            QueryLatencyResultHandle.Initialize<ara::core::Future<QueryLatencyResultOutput>>()};
        ThrowError(QueryLatencyResultResult);
        const ara::core::Result<void> QueryLatencyStatusResult {
            QueryLatencyStatusHandle.Initialize<ara::core::Future<QueryLatencyStatusOutput>>()};
        ThrowError(QueryLatencyStatusResult);
        const ara::core::Result<void> QueryMethodInfoResult {
            QueryMethodInfoHandle.Initialize<ara::core::Future<QueryMethodInfoOutput>>()};
        ThrowError(QueryMethodInfoResult);
        const ara::core::Result<void> QueryMethodTypeResult {
            QueryMethodTypeHandle.Initialize<ara::core::Future<QueryMethodTypeOutput>>()};
        ThrowError(QueryMethodTypeResult);
        const ara::core::Result<void> QueryNodeInfoResult {
            QueryNodeInfoHandle.Initialize<ara::core::Future<QueryNodeInfoOutput>>()};
        ThrowError(QueryNodeInfoResult);
        const ara::core::Result<void> QuerySubNodeEventInfoResult {
            QuerySubNodeEventInfoHandle.Initialize<ara::core::Future<QuerySubNodeEventInfoOutput>>()};
        ThrowError(QuerySubNodeEventInfoResult);
        const ara::core::Result<void> SwitchLatencyModeResult {
            SwitchLatencyModeHandle.Initialize<ara::core::Future<SwitchLatencyModeOutput>>()};
        ThrowError(SwitchLatencyModeResult);
        const ara::core::Result<void> QueryServiceInfoResult {
            QueryServiceInfoHandle.Initialize<ara::core::Future<QueryServiceInfoOutput>>()};
        ThrowError(QueryServiceInfoResult);
        const ara::core::Result<void> QueryFieldInfoResult {
            QueryFieldInfoHandle.Initialize<ara::core::Future<QueryFieldInfoOutput>>()};
        ThrowError(QueryFieldInfoResult);
    }
    static void ThrowError(const ara::core::Result<void>& result)
    {
        if (!(result.HasValue())) {
            ara::core::ErrorCode errorCode {result.Error()};
            throw ara::com::ComException(std::move(errorCode));
        }
    }
public:
    struct QueryAllDataTypeOutput {
        ::rtf::maintaind::DataTypeMap dataTypeList;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(dataTypeList);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(dataTypeList);
        }

        friend bool operator == (const QueryAllDataTypeOutput& lhs, const QueryAllDataTypeOutput& rhs) noexcept
        {
            return (lhs.dataTypeList == rhs.dataTypeList);
        }
    };

    struct QueryDataTypeOutput {
        ::rtf::stdtype::String type;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(type);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(type);
        }

        friend bool operator == (const QueryDataTypeOutput& lhs, const QueryDataTypeOutput& rhs) noexcept
        {
            return (lhs.type == rhs.type);
        }
    };

    struct QueryDataTypeRefListOutput {
        ::rtf::maintaind::DataTypeRefMap dataTypeRefList;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(dataTypeRefList);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(dataTypeRefList);
        }

        friend bool operator == (const QueryDataTypeRefListOutput& lhs, const QueryDataTypeRefListOutput& rhs) noexcept
        {
            return (lhs.dataTypeRefList == rhs.dataTypeRefList);
        }
    };

    struct QueryEventInfoOutput {
        ::rtf::maintaind::QueryEventInfoReturnType eventInfo;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(eventInfo);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(eventInfo);
        }

        friend bool operator == (const QueryEventInfoOutput& lhs, const QueryEventInfoOutput& rhs) noexcept
        {
            return (lhs.eventInfo == rhs.eventInfo);
        }
    };

    struct QueryEventShowOutput {
        ::rtf::stdtype::String type;
        ::rtf::stdtype::String pub;
        ::rtf::stdtype::String pubStatus;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(type);
            fun(pub);
            fun(pubStatus);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(type);
            fun(pub);
            fun(pubStatus);
        }

        friend bool operator == (const QueryEventShowOutput& lhs, const QueryEventShowOutput& rhs) noexcept
        {
            return ((lhs.type == rhs.type) && (lhs.pub == rhs.pub) && (lhs.pubStatus == rhs.pubStatus));
        }
    };

    struct QueryLatencyResultOutput {
        ::rtf::maintaind::LatencyResultMap latencyResultMap;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(latencyResultMap);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(latencyResultMap);
        }

        friend bool operator == (const QueryLatencyResultOutput& lhs, const QueryLatencyResultOutput& rhs) noexcept
        {
            return (lhs.latencyResultMap == rhs.latencyResultMap);
        }
    };

    struct QueryLatencyStatusOutput {
        ::rtf::maintaind::LatencyStatus latencyStatus;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(latencyStatus);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(latencyStatus);
        }

        friend bool operator == (const QueryLatencyStatusOutput& lhs, const QueryLatencyStatusOutput& rhs) noexcept
        {
            return (lhs.latencyStatus == rhs.latencyStatus);
        }
    };

    struct QueryMethodInfoOutput {
        ::rtf::maintaind::QueryMethodInfoReturnType methodInfo;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(methodInfo);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(methodInfo);
        }

        friend bool operator == (const QueryMethodInfoOutput& lhs, const QueryMethodInfoOutput& rhs) noexcept
        {
            return (lhs.methodInfo == rhs.methodInfo);
        }
    };

    struct QueryMethodTypeOutput {
        ::rtf::maintaind::MethodDatatypeInfo methodDatatypeInfo;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(methodDatatypeInfo);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(methodDatatypeInfo);
        }

        friend bool operator == (const QueryMethodTypeOutput& lhs, const QueryMethodTypeOutput& rhs) noexcept
        {
            return (lhs.methodDatatypeInfo == rhs.methodDatatypeInfo);
        }
    };

    struct QueryNodeInfoOutput {
        ::rtf::maintaind::VectorNodeInfo nodeInfoList;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(nodeInfoList);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(nodeInfoList);
        }

        friend bool operator == (const QueryNodeInfoOutput& lhs, const QueryNodeInfoOutput& rhs) noexcept
        {
            return (lhs.nodeInfoList == rhs.nodeInfoList);
        }
    };

    struct QuerySubNodeEventInfoOutput {
        ::rtf::maintaind::EventInfoWithPubSub eventInfoWithSub;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(eventInfoWithSub);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(eventInfoWithSub);
        }

        friend bool operator == (
            const QuerySubNodeEventInfoOutput& lhs, const QuerySubNodeEventInfoOutput& rhs) noexcept
        {
            return (lhs.eventInfoWithSub == rhs.eventInfoWithSub);
        }
    };

    struct SwitchLatencyModeOutput {
        ::rtf::maintaind::ReturnCode result;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(result);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(result);
        }

        friend bool operator == (const SwitchLatencyModeOutput lhs, const SwitchLatencyModeOutput rhs) noexcept
        {
            return (lhs.result == rhs.result);
        }
    };

    struct QueryServiceInfoOutput {
        ::rtf::maintaind::QueryServiceInfoReturnType serviceInfo;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(serviceInfo);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(serviceInfo);
        }

        friend bool operator == (const QueryServiceInfoOutput& lhs, const QueryServiceInfoOutput& rhs) noexcept
        {
            return (lhs.serviceInfo == rhs.serviceInfo);
        }
    };

    struct QueryFieldInfoOutput {
        ::rtf::maintaind::QueryFieldInfoReturnType fieldInfo;

        static bool IsPlane() noexcept
        {
            return false;
        }

        using IsEnumerableTag = void;
        template<typename F>
        void enumerate(F& fun) noexcept
        {
            fun(fieldInfo);
        }

        template<typename F>
        void enumerate(F& fun) const noexcept
        {
            fun(fieldInfo);
        }

        friend bool operator == (const QueryFieldInfoOutput& lhs, const QueryFieldInfoOutput& rhs) noexcept
        {
            return (lhs.fieldInfo == rhs.fieldInfo);
        }
    };

    explicit RTFMaintaindToolsServiceSkeleton(const ara::com::InstanceIdentifier& instanceId,
                           ara::com::MethodCallProcessingMode mode = ara::com::MethodCallProcessingMode::kEvent)
        : skeletonAdapter(std::make_unique<ara::com::internal::skeleton::SkeletonAdapter>(
            ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode)),
          QueryAllDataTypeHandle(skeletonAdapter->GetSkeleton(), methods::QueryAllDataTypeId,
                                 ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryDataTypeHandle(skeletonAdapter->GetSkeleton(), methods::QueryDataTypeId,
                              ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryDataTypeRefListHandle(skeletonAdapter->GetSkeleton(), methods::QueryDataTypeRefListId,
                                     ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryEventInfoHandle(skeletonAdapter->GetSkeleton(), methods::QueryEventInfoId,
                               ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryEventShowHandle(skeletonAdapter->GetSkeleton(), methods::QueryEventShowId,
                               ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryLatencyResultHandle(skeletonAdapter->GetSkeleton(), methods::QueryLatencyResultId,
                                   ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryLatencyStatusHandle(skeletonAdapter->GetSkeleton(), methods::QueryLatencyStatusId,
                                   ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryMethodInfoHandle(skeletonAdapter->GetSkeleton(), methods::QueryMethodInfoId,
                                ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryMethodTypeHandle(skeletonAdapter->GetSkeleton(), methods::QueryMethodTypeId,
                                ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryNodeInfoHandle(skeletonAdapter->GetSkeleton(), methods::QueryNodeInfoId,
                              ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QuerySubNodeEventInfoHandle(skeletonAdapter->GetSkeleton(), methods::QuerySubNodeEventInfoId,
                                      ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          SwitchLatencyModeHandle(skeletonAdapter->GetSkeleton(), methods::SwitchLatencyModeId,
                                  ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryServiceInfoHandle(skeletonAdapter->GetSkeleton(), methods::QueryServiceInfoId,
                                 ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode),
          QueryFieldInfoHandle(skeletonAdapter->GetSkeleton(), methods::QueryFieldInfoId,
                               ::rtf::maintaind::RTFMaintaindToolsService::ServiceIdentifier, instanceId, mode){
        ConstructSkeleton(mode);
    }

    RTFMaintaindToolsServiceSkeleton(const RTFMaintaindToolsServiceSkeleton&) = delete;
    RTFMaintaindToolsServiceSkeleton& operator=(const RTFMaintaindToolsServiceSkeleton&) & = delete;

    virtual ~RTFMaintaindToolsServiceSkeleton() noexcept
    {
        StopOfferService();
    }

    void OfferService()
    {
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryAllDataType, *this,
            methods::QueryAllDataTypeId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryDataType, *this,
            methods::QueryDataTypeId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryDataTypeRefList, *this,
            methods::QueryDataTypeRefListId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryEventInfo, *this,
            methods::QueryEventInfoId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryEventShow, *this,
            methods::QueryEventShowId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryLatencyResult, *this,
            methods::QueryLatencyResultId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryLatencyStatus, *this,
            methods::QueryLatencyStatusId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryMethodInfo, *this,
            methods::QueryMethodInfoId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryMethodType, *this,
            methods::QueryMethodTypeId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryNodeInfo, *this,
            methods::QueryNodeInfoId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QuerySubNodeEventInfo, *this,
            methods::QuerySubNodeEventInfoId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::SwitchLatencyMode, *this,
            methods::SwitchLatencyModeId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryServiceInfo, *this,
            methods::QueryServiceInfoId);
        skeletonAdapter->RegisterMethod(&RTFMaintaindToolsServiceSkeleton::QueryFieldInfo, *this,
            methods::QueryFieldInfoId);
        skeletonAdapter->OfferService();
    }
    void StopOfferService() const noexcept
    {
        skeletonAdapter->StopOfferService();
    }
    ara::core::Future<bool> ProcessNextMethodCall() const
    {
        return skeletonAdapter->ProcessNextMethodCall();
    }
    bool SetMethodThreadNumber(const std::uint16_t number, const std::uint16_t queueSize) const
    {
        return skeletonAdapter->SetMethodThreadNumber(number, queueSize);
    }
    virtual ara::core::Future<QueryAllDataTypeOutput> QueryAllDataType() = 0;
    virtual ara::core::Future<QueryDataTypeOutput> QueryDataType(const ::rtf::stdtype::String& msgName) = 0;
    virtual ara::core::Future<QueryDataTypeRefListOutput> QueryDataTypeRefList() = 0;
    virtual ara::core::Future<QueryEventInfoOutput> QueryEventInfo(const ::rtf::stdtype::String& eventName) = 0;
    virtual ara::core::Future<QueryEventShowOutput> QueryEventShow(const ::rtf::maintaind::QueryDataTypeIndex& index) = 0;
    virtual ara::core::Future<QueryLatencyResultOutput> QueryLatencyResult(
        const ::rtf::maintaind::LatencyQueryInfo& latencyQueryInfo) = 0;
    virtual ara::core::Future<QueryLatencyStatusOutput> QueryLatencyStatus(
        const ::rtf::maintaind::LatencyIndex& eventName) = 0;
    virtual ara::core::Future<QueryMethodInfoOutput> QueryMethodInfo(const ::rtf::stdtype::String& methodName) = 0;
    virtual ara::core::Future<QueryMethodTypeOutput> QueryMethodType(const ::rtf::maintaind::QueryDataTypeIndex& index) = 0;
    virtual ara::core::Future<QueryNodeInfoOutput> QueryNodeInfo(const ::rtf::stdtype::String& appName) = 0;
    virtual ara::core::Future<QuerySubNodeEventInfoOutput> QuerySubNodeEventInfo(
        const ::rtf::maintaind::QuerySubEventInfoIndex& querySubEventInfoIndex) = 0;
    virtual ara::core::Future<SwitchLatencyModeOutput> SwitchLatencyMode(
        const ::rtf::maintaind::LatencySwitch& latencySwitch) = 0;
    virtual ara::core::Future<QueryServiceInfoOutput> QueryServiceInfo(const ::rtf::stdtype::String& serviceName) = 0;
    virtual ara::core::Future<QueryFieldInfoOutput> QueryFieldInfo(const ::rtf::stdtype::String& fieldName) = 0;

    methods::QueryAllDataTypeHandle QueryAllDataTypeHandle;
    methods::QueryDataTypeHandle QueryDataTypeHandle;
    methods::QueryDataTypeRefListHandle QueryDataTypeRefListHandle;
    methods::QueryEventInfoHandle QueryEventInfoHandle;
    methods::QueryEventShowHandle QueryEventShowHandle;
    methods::QueryLatencyResultHandle QueryLatencyResultHandle;
    methods::QueryLatencyStatusHandle QueryLatencyStatusHandle;
    methods::QueryMethodInfoHandle QueryMethodInfoHandle;
    methods::QueryMethodTypeHandle QueryMethodTypeHandle;
    methods::QueryNodeInfoHandle QueryNodeInfoHandle;
    methods::QuerySubNodeEventInfoHandle QuerySubNodeEventInfoHandle;
    methods::SwitchLatencyModeHandle SwitchLatencyModeHandle;
    methods::QueryServiceInfoHandle QueryServiceInfoHandle;
    methods::QueryFieldInfoHandle QueryFieldInfoHandle;
protected:
    RTFMaintaindToolsServiceSkeleton(RTFMaintaindToolsServiceSkeleton&& other) = default;
    RTFMaintaindToolsServiceSkeleton& operator=(RTFMaintaindToolsServiceSkeleton&& other) & = default;
};
} // namespace skeleton
} // namespace maintaind
} // namespace rtf
#endif // RTF_MAINTAIND_RTFMAINTAINDTOOLSSERVICE_SKELETON_H
